=== modified file 'viz/branchwin.py'
--- viz/branchwin.py	2007-10-21 16:25:29 +0000
+++ viz/branchwin.py	2007-10-21 16:29:25 +0000
@@ -95,9 +95,7 @@
 
     def construct_top(self):
         """Construct the top-half of the window."""
-        self.treeview = TreeView()
-
-        self.treeview.set_branch(self.branch, self.start, self.maxnum)
+        self.treeview = TreeView(self.branch, self.start, self.maxnum)
 
         self.treeview.connect("revision-selected",
                 self._treeselection_changed_cb)

=== modified file 'viz/treeview.py'
--- viz/treeview.py	2007-10-21 16:09:12 +0000
+++ viz/treeview.py	2007-10-21 16:29:25 +0000
@@ -29,7 +29,7 @@
                                   ())
     }
 
-    def __init__(self):
+    def __init__(self, branch, start, maxnum):
         gtk.ScrolledWindow.__init__(self)
 
         self.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
@@ -37,6 +37,11 @@
 
         self.construct_treeview()
 
+        self.branch = branch
+        self.branch.lock_read()
+
+        gobject.idle_add(self.populate, start, maxnum)
+
         self.revision = None
         self.children = None
         self.parents  = None
@@ -55,13 +60,7 @@
 
     def get_parents(self):
         return self.parents
-
-    def set_branch(self, branch, start, maxnum):
-        self.branch = branch
-        self.branch.lock_read()
-
-        gobject.idle_add(self.populate, start, maxnum)
-
+        
     def back(self):
         (path, col) = self.treeview.get_cursor()
         revision = self.model[path][treemodel.REVISION]

